
#include <handler/handler.h>

// This line is to make sure we are hooking the same way were are calling
Handler::GateType test = &Handler::Gate;

void* Handler::Gate(void* arg1,void* arg2, void* arg3)
{
	FunctionForHandler* function = Rage->init();

	Handler* handler = static_cast<Handler*>(function->get_handler());
	
	CVector<int>* plugin_hooks = function->get_plugin_hooks();
	CVector<void*>* module_hooks =  function->get_module_hooks();

	handler->init(arg1,arg2,arg3);

	RageHookReturn hook_ret = RageHookIgnored;
	
	handler->call_module_hooks(module_hooks[RageHookPre],hook_ret);

	handler->call_original(function,hook_ret);
		
	handler->call_module_hooks(module_hooks[RageHookPost],hook_ret);

	void* ret = handler->end();

	Rage->end();

	return ret;
}

void Handler::init(void* arg1,void* arg2,void* arg3)
{
	this->Data.Arguments.arg1 = arg1;
	this->Data.Arguments.arg2 = arg2;
	this->Data.Arguments.arg3 = arg3;
}

void Handler::call_original(FunctionForHandler* function,RageHookReturn& ret)
{
	if(ret == RageHookSupercede)
		return;

	GateType original_address = (GateType) function->get_original_address();
	
	function->pre_call();
	
	void *original_ret = original_address(
		Data.Arguments.arg1,
		Data.Arguments.arg2,
		Data.Arguments.arg3
	);

	function->post_call();

	if(ret != RageHookOverride)
	{
		Data.Return = original_ret;
	}
}

void* Handler::end()
{
	return Data.Return;
}

void Handler::call_module_hooks(CVector<void*>& hooks,RageHookReturn& ret)
{
	if(!hooks.size())
		return;

	RageHookReturn thisRet = RageHookIgnored;

	for(unsigned int i=0;i<hooks.size();i++)
	{
		ModuleHookType module_hook = (ModuleHookType) hooks[i];

		thisRet = module_hook(
			Data.Arguments.arg1,
			Data.Arguments.arg2,
			Data.Arguments.arg3,
			Data.Return
		);

		if( thisRet > ret )
		{
			ret = thisRet; 
		}
	}
}

int Handler::create_plugin_hook(AMX* amx,const char* function_name)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "This handler can't be used by amxx");
	return 0;
}

cell Handler::rage_call(FunctionForHandler* function,AMX* amx,cell* params)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "This handler can't be used by amxx");
	return 0;
}

cell Handler::rage_set_param(AMX* amx,cell* params)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "This handler can't be used by amxx");
	return 0;
}

cell Handler::rage_set_return(AMX* amx,cell* params)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "This handler can't be used by amxx");
	return 0;
}

cell Handler::rage_get_return(AMX* amx,cell* params)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "This handler can't be used by amxx");
	return 0;
}

Handler::Handler(char* name) : name(name)
{
	
}

char* Handler::get_name()
{
	return this->name;
}

void* Handler::get_gate_address()
{
	return (void*)&Gate;
}

int Handler::AMXX_Detach()
{
#ifdef FN_AMXX_DETACH
	FN_AMXX_DETACH();
#endif // FN_AMXX_DETACH

	return AMXX_OK;
}

int Handler::AMXX_PluginsLoaded()
{
#ifdef FN_AMXX_PLUGINSLOADED
	FN_AMXX_PLUGINSLOADED();
#endif // FN_AMXX_PLUGINSLOADED
	return AMXX_OK;
}

void Handler::AMXX_PluginsUnloaded()
{
#ifdef FN_AMXX_PLUGINSUNLOADED
	FN_AMXX_PLUGINSUNLOADED();
#endif // FN_AMXX_PLUGINSUNLOADED
}

void Handler::AMXX_PluginsUnloading()
{
#ifdef FN_AMXX_PLUGINSUNLOADING
	FN_AMXX_PLUGINSUNLOADING();
#endif // FN_AMXX_PLUGINSUNLOADING
}
