
#ifndef _INCLUDE_HANDLER__H_
#define _INCLUDE_HANDLER__H_

#include <handler/handler_for_rage.h>
#include <rage/rage_for_handler.h>
#include <rage/rage_hook_return.h>
#include <rage/rage_hook_phase.h>
#include <CVector.h>

typedef int DUMMY;
const int DUMMY_VAL = 0;

extern RageForHandler* Rage;

class Handler : public HandlerForRage
{
	private:
		
		char* name;
		
		struct ArgumentsType
		{
			void* arg1;
			void* arg2;
			void* arg3;
		};

		struct 
		{
			ArgumentsType Arguments;	
			void* Return;
			
		} Data;

	public:
		
		Handler(char* name);

		char* get_name();
		void* get_gate_address();
	
		typedef RageHookReturn (*ModuleHookType)(void*&,void*&,void*&,void*& ret);

		static void* Gate(void*,void*,void*);
		typedef void* (*GateType)(void*,void*,void*);
		
		void init(void*,void*,void*);

		void call_original(FunctionForHandler* function,RageHookReturn& ret);
		void* end();

		void call_module_hooks(CVector<void*>& hooks,RageHookReturn& ret);

		int create_plugin_hook(AMX* amx,const char* function_name);
		cell rage_call(FunctionForHandler* function,AMX* amx,cell* params);
		cell rage_set_param(AMX* amx,cell* params);
		cell rage_set_return(AMX* amx,cell* params);
		cell rage_get_return(AMX* amx,cell* params);
		
		int AMXX_Detach();
		int AMXX_PluginsLoaded();
		void AMXX_PluginsUnloaded();
		void AMXX_PluginsUnloading();
};

#endif
