
#ifndef HORNETS_GUN_H
#define HORNETS_GUN_H

#include <weapon_utils.h>
#include <weapon_config.h>

RageHookReturn PreThink( void*& arg1 );
RageHookReturn AddToPlayer( void*& arg1, int& ret );
RageHookReturn OnSetModel( edict_t*& pWeapon, const char*& model );

#ifdef __linux__
	void Precache( void* arg1 );
	int GetItemInfo( void* arg1, void* arg2 );
	void FirstSpawn( void* arg1 );
	int Deploy( void* arg1 );
	void Holster( void* arg1, int arg2 );
	void PrimaryAttack( void* arg1 );
	void SecondaryAttack( void* arg1 );
	void Reload( void* arg1 );
	void WeaponIdle( void* arg1 );
#else
	void _fastcall Precache( void* arg1, DUMMY );
	int _fastcall GetItemInfo( void* arg1, DUMMY, void* arg2 );
	void _fastcall FirstSpawn( void* arg1, DUMMY );
	int _fastcall Deploy( void* arg1, DUMMY );
	void _fastcall Holster( void* arg1, DUMMY, int arg2 );
	void _fastcall PrimaryAttack( void* arg1, DUMMY );
	void _fastcall SecondaryAttack( void* arg1, DUMMY );
	void _fastcall Reload( void* arg1, DUMMY );
	void _fastcall WeaponIdle( void* arg1, DUMMY );
#endif

inline float GetTimeWeaponIdle( entvars_t* _pev )
{
	return _pev->fuser1;
}

inline float GetNextPrimaryAttack( entvars_t* pev )
{
	return pev->fuser2;
}

inline float GetNextSecondaryAttack( entvars_t* pev )
{
	return pev->fuser3;
}

inline float GetRechargeTime( entvars_t* pev )
{
	return pev->fuser4;
}

inline void SetTimeWeaponIdle( entvars_t* pev, float newValue )
{
	pev->fuser1 = newValue;
}

inline void SetNextPrimaryAttack( entvars_t* pev, float newValue )
{
	pev->fuser2 = newValue;
}

inline void SetNextSecondaryAttack( entvars_t* pev, float newValue )
{
	pev->fuser3 = newValue;
}

inline void SetRechargeTime( entvars_t* pev, float newValue )
{	
	pev->fuser4 = newValue;
}



#endif // HORNETS_GUN_H