
#ifndef WEAPONE_UTILS_H
#define WEAPONE_UTILS_H

#include <module.h>

extern int m_pfnThink;
extern int m_pfnTouch;

entvars_t*	CreateEntity				( char* classname, Vector& vecOrigin, Vector& vecAngles, edict_t* pentOwner );
int			UTIL_EntitiesInBo	( void **pList, int listMax, const Vector &mins, const Vector &maxs, int flagMask );
Vector		UTIL_VecToAngles	( const Vector &vec );
bool		IsVisible			( entvars_t *pevHornet, entvars_t *pevEntity );
bool		FInViewCone			( entvars_t *pevHornet, entvars_t *pevEntity );
void*		BestVisibleEnemy	( void* arg1, int distance );

#ifdef __linux__
	typedef void	( *FuncFallInit )					( void* );
	typedef int		( *FuncDefaultDeploy )				( void*, char*, char*, int, char*, int );
	typedef void	( *FuncSendWeaponAnim )				( void*, int, int );
	typedef Vector	( *FuncGetGunPosition )				( void* );
	//typedef void	( *FuncResetSequenceInfo )			( void* );
	//typedef float	( *FuncStudioFrameAdvance )			( void*, float );
	typedef int		( *OnTakeDamageType )				( void*, entvars_s*, entvars_s*, float, int );
	//typedef int	( *FuncIRelationship )				( void*, void* );
	typedef void	( *FuncSetAnimation )				( void*, int );
	typedef void	( *FuncSUB_Remove )					( void* );
	//typedef void	( *FuncLook )						( void*, int );
	//typedef void*	( *FuncBestVisibleEnemy )			( void* );
	//typedef int	( *FuncFInViewCone )				( void*, void* );
	typedef void	( *FuncSpawn )						( void* );
#else
	typedef void	( _fastcall *FuncFallInit )			( void*, DUMMY );
	typedef int		( _fastcall *FuncDefaultDeploy )	( void*, DUMMY, char*, char*, int, char*, int );
	typedef void	( _fastcall *FuncSendWeaponAnim )	( void*, DUMMY, int, int );
	typedef Vector*	( _fastcall *FuncGetGunPosition )	( void*, DUMMY, Vector* );
	//typedef void	( _fastcall *FuncResetSequenceInfo )( void*, DUMMY );
	//typedef float	( _fastcall *FuncStudioFrameAdvance )( void*, DUMMY, float );
	typedef int		( _fastcall *OnTakeDamageType )		( void*, DUMMY, entvars_s*, entvars_s*, float, int );
	//typedef int	( _fastcall *FuncIRelationship )	( void*, DUMMY, void* );
	typedef void	( _fastcall *FuncSetAnimation )		( void*, DUMMY, int );
	typedef void	( _fastcall *FuncSUB_Remove )		( void*, DUMMY );
	//typedef void	( _fastcall *FuncLook )				( void*, DUMMY, int );
	//typedef void*	( _fastcall *FuncBestVisibleEnemy )	( void*, DUMMY );
	//typedef int	( _fastcall *FuncFInViewCone )		( void*, DUMMY, void* );
	typedef void	( _fastcall *FuncSpawn )			( void*, DUMMY );
#endif

typedef void* ( *FuncCreate ) ( char*, Vector &, Vector &, edict_t* );

extern FuncFallInit FallInit;
extern FuncDefaultDeploy DefaultDeploy;
extern FuncSendWeaponAnim SendWeaponAnim;
extern FuncGetGunPosition GetGunPosition;
extern FuncCreate Create;
//extern FuncResetSequenceInfo ResetSequenceInfo;
//extern FuncStudioFrameAdvance StudioFrameAdvance;
//extern FuncIRelationship IRelationship;
extern FuncSetAnimation SetAnimation;
extern FuncSUB_Remove SUB_Remove;
//extern FuncLook Look;
//extern FuncBestVisibleEnemy BestVisibleEnemy;
//extern FuncFInViewCone FInViewCone;
extern FuncSpawn Spawn;

extern VirtualFunctionForModule* VFTakeDamage;
//VirtualFunctionForModule* VFIRelationship;
//VirtualFunctionForModule* VFLook;
//VirtualFunctionForModule* VFBestVisibleEnemy;
//VirtualFunctionForModule* VFFInViewCone;
extern VirtualFunctionForModule* VFSpawn;

#define ITEM_FLAG_SELECTONEMPTY		1
#define ITEM_FLAG_NOAUTORELOAD		2
#define ITEM_FLAG_NOAUTOSWITCHEMPTY	4
#define ITEM_FLAG_LIMITINWORLD		8
#define ITEM_FLAG_EXHAUSTIBLE		16

#define LOUD_GUN_VOLUME			1000
#define NORMAL_GUN_VOLUME		600
#define QUIET_GUN_VOLUME		200

#define	BRIGHT_GUN_FLASH		512
#define NORMAL_GUN_FLASH		256
#define	DIM_GUN_FLASH			128

#define BIG_EXPLOSION_VOLUME	2048
#define NORMAL_EXPLOSION_VOLUME	1024
#define SMALL_EXPLOSION_VOLUME	512

#define CHAN_AUTO			0
#define CHAN_WEAPON			1
#define	CHAN_VOICE			2
#define CHAN_ITEM			3
#define	CHAN_BODY			4
#define CHAN_STREAM			5	
#define CHAN_STATIC			6

#define DMG_BULLET			(1 << 1)	// shot
#define PLAYER_ATTACK1		5

typedef struct
{
	int		iSlot;
	int		iPosition;
	const char	*pszAmmo1;	
	int		iMaxAmmo1;	
	const char	*pszAmmo2;	
	int		iMaxAmmo2;		
	const char	*pszName;
	int		iMaxClip;
	int		iId;
	int		iFlags;
	int		iWeight;
} ItemInfo;

inline edict_t* INDEXENT2( int iEdictNum )
{ 
	if( iEdictNum >= 1 && iEdictNum <= gpGlobals->maxClients )
		return MF_GetPlayerEdict( iEdictNum );

	else
		return ( *g_engfuncs.pfnPEntityOfEntIndex )( iEdictNum ); 
}

inline edict_t *PrivateToEdict( const void *pdata )
{
	if( !pdata )
	{
		return NULL;
	}

	int index = Rage->private_to_index( pdata );
	entvars_t* pev = NULL;

	if( index > 0 )
	{
		pev = Rage->index_to_entvar( index );
	}

	if( !pev )
	{
		return NULL;
	}

	return pev->pContainingEntity;
};

inline entvars_t* EdictToEntvar( edict_t * e )
{
	if ( !e )
		return NULL;

	return &e->v;
}

inline entvars_t* PrivateToEntvar( void* ptr )
{
	return EdictToEntvar( PrivateToEdict( ptr ) );
}


inline void set_pdata_float( edict_t* e, int offset, float newValue )
{
	*( ( float* )e->pvPrivateData + offset ) = newValue;
}

inline void set_pdata_int( edict_t* e, int offset, int newValue )
{
	*( ( int* )e->pvPrivateData + offset ) = newValue;
}

inline float get_pdata_float( edict_t* e, int offset )
{
	return *( ( float* )e->pvPrivateData + offset );
}

inline int get_pdata_int( edict_t* e, int offset )
{
	return *( ( int* )e->pvPrivateData + offset );
}

inline void* get_pdata_cbase( edict_t* e, int offset )
{
	return *( ( void** )( ( int* )e->pvPrivateData + offset ) );
}


inline void _SetTouch_( edict_t* e, void* address )
{
	printf( "SetTouch_ = %x (%d) %x\n", e, Rage->entvar_to_index( &e->v ), address );
	*( ( long* )e->pvPrivateData + m_pfnTouch ) = ( long )( address );
	//printf( "\tSetTouch_ = %x\n", *( ( long* )e->pvPrivateData + m_pfnTouch ) );
}

inline void SetThink_( edict_t* e, void* address )
{
	*( ( long* )e->pvPrivateData + m_pfnThink ) = ( long )address;
}

#endif // WEAPONE_UTILS_H