
#include <module/module.h>
#include <module.h>

Module::Module(char* name,char* author,char* version) : name(name), author(author), version(version)
{
	
}

char* Module::get_name()
{
	return this->name;
}

char* Module::get_author()
{
	return this->author;
}

char* Module::get_version()
{
	return this->version;
}

void Module::LoadedLibrary(LibraryForModule* library)
{
	//OnLoadLibrary(library);
}
	
void Module::LoadedFunction(FunctionForModule* function)
{
	//OnLoadFunction(function);
}

void Module::LoadedVirtualFunction(VirtualFunctionForModule* virtual_function)
{
	//OnLoadVirtualFunction(virtual_function);
}

void Module::LoadedFunctionIncomplete(FunctionIncompleteForModule* function_incomplete)
{
	OnLoadFunctionIncomplete(function_incomplete);
}

// request function
#define REQFUNC(name, fptr, type) if ((fptr = (type)reqFnptrFunc(name)) == 0) return AMXX_FUNC_NOT_PRESENT
// request optional function
#define REQFUNC_OPT(name, fptr, type) fptr = (type)reqFnptrFunc(name)

int Module::AMXX_Attach(PFN_REQ_FNPTR reqFnptrFunc)
{
	// Check pointer
	if (!reqFnptrFunc)
		return AMXX_PARAM;

	g_fn_RequestFunction = reqFnptrFunc;

	// Req all known functions
	// Misc
#ifdef AMXX_FUNC_BUILD_PATHNAME
	REQFUNC("BuildPathname", g_fn_BuildPathname, PFN_BUILD_PATHNAME);
#endif
#ifdef AMXX_FUNC_BUILD_PATHNAME_R
	REQFUNC("BuildPathnameR", g_fn_BuildPathnameR, PFN_BUILD_PATHNAME_R);
#endif
#ifdef AMXX_FUNC_PRINT_SRVCONSOLE
	REQFUNC("PrintSrvConsole", g_fn_PrintSrvConsole, PFN_PRINT_SRVCONSOLE);
#endif
#ifdef AMXX_FUNC_GET_MODNAME
	REQFUNC("GetModname", g_fn_GetModname, PFN_GET_MODNAME);
#endif
#ifdef AMXX_FUNC_LOG
	REQFUNC("Log", g_fn_Log, PFN_LOG);
#endif
#ifdef AMXX_FUNC_LOG_ERROR
	REQFUNC("LogError", g_fn_LogErrorFunc, PFN_LOG_ERROR);
#endif
#ifdef AMXX_FUNC_MERGEDEFINITION_FILE
	REQFUNC("MergeDefinitionFile", g_fn_MergeDefinition_File, PFN_MERGEDEFINITION_FILE);
#endif
#ifdef AMXX_FUNC_FORMAT
	REQFUNC("Format", g_fn_Format, PFN_FORMAT);
#endif
#ifdef AMXX_FUNC_REGISTERFUNCTION
	REQFUNC("RegisterFunction", g_fn_RegisterFunction, PFN_REGISTERFUNCTION);
#endif
#ifdef AMXX_FUNC_REGISTERFUNCTIONEX
	REQFUNC("RegisterFunctionEx", g_fn_RegisterFunctionEx, PFN_REGISTERFUNCTIONEX);
#endif

	// Amx scripts
#ifdef AMXX_FUNC_GET_AMXSCRIPT
	REQFUNC("GetAmxScript", g_fn_GetAmxScript, PFN_GET_AMXSCRIPT);
#endif
#ifdef AMXX_FUNC_FIND_AMXSCRIPT_BYAMX
	REQFUNC("FindAmxScriptByAmx", g_fn_FindAmxScriptByAmx, PFN_FIND_AMXSCRIPT_BYAMX);
#endif
#ifdef AMXX_FUNC_FIND_AMXSCRIPT_BYNAME
	REQFUNC("FindAmxScriptByName", g_fn_FindAmxScriptByName, PFN_FIND_AMXSCRIPT_BYNAME);
#endif
#ifdef AMXX_FUNC_LOAD_AMXSCRIPT
	REQFUNC("LoadAmxScript", g_fn_LoadAmxScript, PFN_LOAD_AMXSCRIPT);
#endif
#ifdef AMXX_FUNC_UNLOAD_AMXSCRIPT
	REQFUNC("UnloadAmxScript", g_fn_UnloadAmxScript, PFN_UNLOAD_AMXSCRIPT);
#endif
#ifdef AMXX_FUNC_GET_AMXSCRIPTNAME
	REQFUNC("GetAmxScriptName", g_fn_GetAmxScriptName, PFN_GET_AMXSCRIPTNAME);
#endif

	// String / mem in amx scripts support
#ifdef AMXX_FUNC_SET_AMXSTRING
	REQFUNC("SetAmxString", g_fn_SetAmxString, PFN_SET_AMXSTRING);
#endif
#ifdef AMXX_FUNC_GET_AMXSTRING
	REQFUNC("GetAmxString", g_fn_GetAmxString, PFN_GET_AMXSTRING);
#endif
#ifdef AMXX_FUNC_GET_AMXSTRINGLEN
	REQFUNC("GetAmxStringLen", g_fn_GetAmxStringLen, PFN_GET_AMXSTRINGLEN);
#endif
#ifdef AMXX_FUNC_FORMAT_AMXSTRING
	REQFUNC("FormatAmxString", g_fn_FormatAmxString, PFN_FORMAT_AMXSTRING);
#endif
#ifdef AMXX_FUNC_COPY_AMXMEMORY
	REQFUNC("CopyAmxMemory", g_fn_CopyAmxMemory, PFN_COPY_AMXMEMORY);
#endif
#ifdef AMXX_FUNC_GET_AMXADDR
	REQFUNC("GetAmxAddr", g_fn_GetAmxAddr, PFN_GET_AMXADDR);
#endif

#ifdef AMXX_FUNC_AMX_EXEC
	REQFUNC("amx_Exec", g_fn_AmxExec, PFN_AMX_EXEC);
#endif
#ifdef AMXX_FUNC_AMX_EXECV
	REQFUNC("amx_Execv", g_fn_AmxExecv, PFN_AMX_EXECV);
#endif
#ifdef AMXX_FUNC_AMX_FINDPUBLIC
	REQFUNC("amx_FindPublic", g_fn_AmxFindPublic, PFN_AMX_FINDPUBLIC);
#endif
#ifdef AMXX_FUNC_AMX_ALLOT
	REQFUNC("amx_Allot", g_fn_AmxAllot, PFN_AMX_ALLOT);
#endif
#ifdef AMXX_FUNC_AMX_FINDNATIVE
	REQFUNC("amx_FindNative", g_fn_AmxFindNative, PFN_AMX_FINDNATIVE);
#endif

	// Natives / Forwards
#ifdef AMXX_FUNC_ADD_NATIVES
	REQFUNC("AddNatives", g_fn_AddNatives, PFN_ADD_NATIVES);
#endif
#ifdef AMXX_FUNC_ADD_NEW_NATIVES
	REQFUNC("AddNewNatives", g_fn_AddNewNatives, PFN_ADD_NEW_NATIVES);
#endif
#ifdef AMXX_FUNC_RAISE_AMXERROR
	REQFUNC("RaiseAmxError", g_fn_RaiseAmxError, PFN_RAISE_AMXERROR);
#endif
#ifdef AMXX_FUNC_REGISTER_FORWARD
	REQFUNC("RegisterForward", g_fn_RegisterForward, PFN_REGISTER_FORWARD);
#endif
#ifdef AMXX_FUNC_REGISTER_SPFORWARD
	REQFUNC("RegisterSPForward", g_fn_RegisterSPForward, PFN_REGISTER_SPFORWARD);
#endif
#ifdef AMXX_FUNC_REGISTER_SPFORWARD_BYNAME
	REQFUNC("RegisterSPForwardByName", g_fn_RegisterSPForwardByName, PFN_REGISTER_SPFORWARD_BYNAME);
#endif
#ifdef AMXX_FUNC_UNREGISTER_SPFORWARD
	REQFUNC("UnregisterSPForward", g_fn_UnregisterSPForward, PFN_UNREGISTER_SPFORWARD);
#endif
#ifdef AMXX_FUNC_EXECUTE_FORWARD
	REQFUNC("ExecuteForward", g_fn_ExecuteForward, PFN_EXECUTE_FORWARD);
#endif
#ifdef AMXX_FUNC_PREPARE_CELLARRAY
	REQFUNC("PrepareCellArray", g_fn_PrepareCellArray, PFN_PREPARE_CELLARRAY);
#endif
#ifdef AMXX_FUNC_PREPARE_CHARARRAY
	REQFUNC("PrepareCharArray", g_fn_PrepareCharArray, PFN_PREPARE_CHARARRAY);
#endif
#ifdef AMXX_FUNC_PREPARE_CELLARRAY_A
	REQFUNC("PrepareCellArrayA", g_fn_PrepareCellArrayA, PFN_PREPARE_CELLARRAY_A);
#endif
#ifdef AMXX_FUNC_PREPARE_CHARARRAY_A
	REQFUNC("PrepareCharArrayA", g_fn_PrepareCharArrayA, PFN_PREPARE_CHARARRAY_A);
#endif
	// Player
#ifdef AMXX_FUNC_IS_PLAYER_VALID
	REQFUNC("IsPlayerValid", g_fn_IsPlayerValid, PFN_IS_PLAYER_VALID);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_NAME
	REQFUNC("GetPlayerName", g_fn_GetPlayerName, PFN_GET_PLAYER_NAME);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_IP
	REQFUNC("GetPlayerIP", g_fn_GetPlayerIP, PFN_GET_PLAYER_IP);
#endif
#ifdef AMXX_FUNC_IS_PLAYER_INGAME
	REQFUNC("IsPlayerInGame", g_fn_IsPlayerIngame, PFN_IS_PLAYER_INGAME);
#endif		
#ifdef AMXX_FUNC_IS_PLAYER_BOT
	REQFUNC("IsPlayerBot", g_fn_IsPlayerBot, PFN_IS_PLAYER_BOT);
#endif	
#ifdef AMXX_FUNC_IS_PLAYER_AUTHORIZED
	REQFUNC("IsPlayerAuthorized", g_fn_IsPlayerAuthorized, PFN_IS_PLAYER_AUTHORIZED);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_TIME
	REQFUNC("GetPlayerTime", g_fn_GetPlayerTime, PFN_GET_PLAYER_TIME);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_PLAYTIME
	REQFUNC("GetPlayerPlayTime", g_fn_GetPlayerPlayTime, PFN_GET_PLAYER_PLAYTIME);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_CURWEAPON
	REQFUNC("GetPlayerCurweapon", g_fn_GetPlayerCurweapon, PFN_GET_PLAYER_CURWEAPON);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_TEAMID
	REQFUNC("GetPlayerTeamID", g_fn_GetPlayerTeamID, PFN_GET_PLAYER_TEAMID);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_TEAM
	REQFUNC("GetPlayerTeam",g_fn_GetPlayerTeam, PFN_GET_PLAYER_TEAM);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_DEATHS
	REQFUNC("GetPlayerDeaths", g_fn_GetPlayerDeaths, PFN_GET_PLAYER_DEATHS);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_MENU
	REQFUNC("GetPlayerMenu", g_fn_GetPlayerMenu, PFN_GET_PLAYER_MENU);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_KEYS
	REQFUNC("GetPlayerKeys", g_fn_GetPlayerKeys, PFN_GET_PLAYER_KEYS);
#endif
#ifdef AMXX_FUNC_IS_PLAYER_ALIVE
	REQFUNC("IsPlayerAlive", g_fn_IsPlayerAlive, PFN_IS_PLAYER_ALIVE);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_FRAGS
	REQFUNC("GetPlayerFrags", g_fn_GetPlayerFrags, PFN_GET_PLAYER_FRAGS);
#endif
#ifdef AMXX_FUNC_IS_PLAYER_CONNECTING
	REQFUNC("IsPlayerConnecting", g_fn_IsPlayerConnecting, PFN_IS_PLAYER_CONNECTING);
#endif
#ifdef AMXX_FUNC_IS_PLAYER_HLTV
	REQFUNC("IsPlayerHLTV", g_fn_IsPlayerHLTV, PFN_IS_PLAYER_HLTV);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_ARMOR
	REQFUNC("GetPlayerArmor", g_fn_GetPlayerArmor, PFN_GET_PLAYER_ARMOR);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_HEALTH
	REQFUNC("GetPlayerHealth", g_fn_GetPlayerHealth, PFN_GET_PLAYER_HEALTH);
#endif
#ifdef AMXX_FUNC_GETPLAYERFLAGS
	REQFUNC("GetPlayerFlags", g_fn_GetPlayerFlags, PFN_GETPLAYERFLAGS);
#endif
#ifdef AMXX_FUNC_GET_PLAYER_EDICT
	REQFUNC("GetPlayerEdict", g_fn_GetPlayerEdict, PFN_GET_PLAYER_EDICT);
#endif
#ifdef AMXX_FUNC_AMX_PUSH
	REQFUNC("amx_Push", g_fn_AmxPush, PFN_AMX_PUSH);
#endif
#ifdef AMXX_FUNC_SET_TEAM_INFO
	REQFUNC("SetPlayerTeamInfo", g_fn_SetTeamInfo, PFN_SET_TEAM_INFO);
#endif
#ifdef AMXX_FUNC_PLAYER_PROP_ADDR
	REQFUNC("PlayerPropAddr", g_fn_PlayerPropAddr, PFN_PLAYER_PROP_ADDR);
#endif
#ifdef AMXX_FUNC_REG_AUTH_FUNC
	REQFUNC("RegAuthFunc", g_fn_RegAuthFunc, PFN_REG_AUTH_FUNC);
#endif
#ifdef AMXX_FUNC_UNREG_AUTH_FUNC
	REQFUNC("UnregAuthFunc", g_fn_UnregAuthFunc, PFN_UNREG_AUTH_FUNC);
#endif

	//Added in 1.75 
#ifdef AMXX_FUNC_FINDLIBRARY
	REQFUNC("FindLibrary", g_fn_FindLibrary, PFN_FINDLIBRARY);
#endif
#ifdef AMXX_FUNC_ADDLIBRARIES
	REQFUNC("AddLibraries", g_fn_AddLibraries, PFN_ADDLIBRARIES);
#endif
#ifdef AMXX_FUNC_REMOVELIBRARIES
	REQFUNC("RemoveLibraries", g_fn_RemoveLibraries, PFN_REMOVELIBRARIES);
#endif
#ifdef AMXX_FUNC_OVERRIDENATIVES
	REQFUNC("OverrideNatives", g_fn_OverrideNatives, PFN_OVERRIDENATIVES);
#endif
#ifdef AMXX_FUNC_GETLOCALINFO
	REQFUNC("GetLocalInfo", g_fn_GetLocalInfo, PFN_GETLOCALINFO);
#endif
#ifdef AMXX_FUNC_AMX_REREGISTER
	REQFUNC("AmxReregister", g_fn_AmxReRegister, PFN_AMX_REREGISTER);
#endif

#ifdef AMXX_FUNC_MESSAGE_BLOCK
	REQFUNC("MessageBlock", g_fn_MessageBlock, PFN_MESSAGE_BLOCK);
#endif
	
#ifdef MEMORY_TEST
	// Memory
	REQFUNC_OPT("Allocator", g_fn_Allocator, PFN_ALLOCATOR);
	REQFUNC_OPT("Reallocator", g_fn_Reallocator, PFN_REALLOCATOR);
	REQFUNC_OPT("Deallocator", g_fn_Deallocator, PFN_DEALLOCATOR);
#endif

#ifdef AMXX_FUNC_CELL_TO_REAL
	REQFUNC("CellToReal", g_fn_CellToReal, PFN_CELL_TO_REAL);
#endif
#ifdef AMXX_FUNC_REAL_TO_CELL
	REQFUNC("RealToCell", g_fn_RealToCell, PFN_REAL_TO_CELL);
#endif

#ifdef FN_AMXX_ATTACH
	FN_AMXX_ATTACH();
#endif // FN_AMXX_ATACH

	return AMXX_OK;
}


int Module::AMXX_Detach()
{
#ifdef FN_AMXX_DETACH
	FN_AMXX_DETACH();
#endif // FN_AMXX_DETACH

	return AMXX_OK;
}

int Module::AMXX_PluginsLoaded()
{
#ifdef FN_AMXX_PLUGINSLOADED
	FN_AMXX_PLUGINSLOADED();
#endif // FN_AMXX_PLUGINSLOADED
	return AMXX_OK;
}

void Module::AMXX_PluginsUnloaded()
{
#ifdef FN_AMXX_PLUGINSUNLOADED
	FN_AMXX_PLUGINSUNLOADED();
#endif // FN_AMXX_PLUGINSUNLOADED
}

void Module::AMXX_PluginsUnloading()
{
#ifdef FN_AMXX_PLUGINSUNLOADING
	FN_AMXX_PLUGINSUNLOADING();
#endif // FN_AMXX_PLUGINSUNLOADING
}
